//+------------------------------------------------------------------+
//|                                              WaterskiguyScan.mq4 |
//+------------------------------------------------------------------+

//#property show_inputs
#property indicator_chart_window

extern color LongColor = Green;
extern color ShortColor = Red;
extern string CurrencySuffix = "";
extern string FontName  = "Arial Bold";
extern int    FontSize  = 11;
extern int HorizPos = 0;
extern int VertPos = 0;
extern int VertSpacing = 14;
extern int Window = 0;
extern int Corner = 0;

color colr;
string objname;
string Symbols[];
string AllPairs[];
string TextLine;
string TrendText;
string SpreadText;
int SymbolCount;
double High0;
double High1;
double High2;
double High3;
double High4;
double Low0;
double Low1;
double Low2;
double Low3;
double Low4;
double spr;
int LongBars;
int ShortBars;
int dig;


//+------------------------------------------------------------------+
int init()  {
//+------------------------------------------------------------------+
//  Comment("");
  del_obj();
  CreateSymbolList();
  ArrayCopy(AllPairs, Symbols);   
  return(0);
}
//+------------------------------------------------------------------+
int deinit()  {
//+------------------------------------------------------------------+
//  Comment("");
  del_obj();
  return(0);
}
//+------------------------------------------------------------------+
int start()  {
//+------------------------------------------------------------------+

   int c;

   for(int i = 0; i < ArraySize(AllPairs); i++)
   {
   High0 = iHigh(AllPairs[i], PERIOD_W1, 0);
   High1 = iHigh(AllPairs[i], PERIOD_W1, 1);
   High2 = iHigh(AllPairs[i], PERIOD_W1, 2);
   High3 = iHigh(AllPairs[i], PERIOD_W1, 3);
   High4 = iHigh(AllPairs[i], PERIOD_W1, 4);
   Low0 = iLow(AllPairs[i], PERIOD_W1, 0);
   Low1 = iLow(AllPairs[i], PERIOD_W1, 1);
   Low2 = iLow(AllPairs[i], PERIOD_W1, 2);
   Low3 = iLow(AllPairs[i], PERIOD_W1, 3);
   Low4 = iLow(AllPairs[i], PERIOD_W1, 4);
   
   LongBars = 0;
   ShortBars = 0;
   
   LongBars = DetermineTrendLong();
   if (LongBars != 0) TrendText = StringConcatenate(" Long Bars = ", LongBars);
   ShortBars = DetermineTrendShort();
   if (ShortBars != 0) TrendText = StringConcatenate(" Short Bars = ", ShortBars);   
   
   dig = MarketInfo(AllPairs[i],MODE_DIGITS);
   spr = MarketInfo(AllPairs[i],MODE_SPREAD);
   if (dig == 3 || dig == 5) spr /= 10;
   
   SpreadText = StringConcatenate(" Spread = ", spr);
   
      if (LongBars !=0 || ShortBars !=0) 
      {
         c++;
         WriteText(AllPairs[i],c);
       
//         TextLine=StringConcatenate(TextLine, AllPairs[i], TrendText, SpreadText, "\n");
      }
   }

//   Comment(TextLine);
  
  return(0);
}

//+------------------------------------------------------------------+
//| Creates the array of pair symbols to check                       |
//+------------------------------------------------------------------+   
string CreateSymbolList()
  {
   string allsyms;
   string Currencies[] = {"AED", "AUD", "BHD", "BRL", "CAD", "CHF", "CNY", "CYP", "CZK", "DKK", "DZD", "EEK", "EGP", "EUR", "GBP", "HKD", "HRK", "HUF", "IDR", "ILS", "INR", "IQD", "IRR", "ISK", "JOD", "JPY", "KRW", "KWD", "LBP", "LTL", "LVL", "LYD", "MAD", "MXN", "MYR", "NOK", "NZD", "OMR", "PHP", "PLN", "QAR", "RON", "RUB", "SAR", "SEK", "SGD", "SKK", "SYP", "THB", "TND", "TRY", "TWD", "USD", "VEB", "XAG", "XAU", "YER", "ZAR"};
   int CurrencyCount = ArrayRange(Currencies, 0);
   int Loop, SubLoop;
   string TempSymbol;
   for(Loop = 0; Loop < CurrencyCount; Loop++)
       for(SubLoop = 0; SubLoop < CurrencyCount; SubLoop++)
         {
           TempSymbol = Currencies[Loop] + Currencies[SubLoop] + CurrencySuffix;
           if(MarketInfo(TempSymbol, MODE_BID) > 0)
             {
               ArrayResize(Symbols, SymbolCount + 1);
               Symbols[SymbolCount] = TempSymbol;
               allsyms = allsyms + TempSymbol +"n";
               SymbolCount++;
             }
             
/*           TempSymbol = Currencies[Loop] + Currencies[SubLoop] +"m";
           if(MarketInfo(TempSymbol, MODE_BID) > 0)
             {
               ArrayResize(Symbols, SymbolCount + 1);
               Symbols[SymbolCount] = TempSymbol;
               allsyms = allsyms + TempSymbol +"n";
               SymbolCount++;
             }  */
         }
   return(allsyms);
  }
  
int DetermineTrendLong()
{

if (High0 > High1 && High1 > High2 && High2 > High3 && High3 > High4 &&
    Low0 > Low1 && Low1 > Low2 && Low2 > Low3 && Low3 > Low4) return(5);
if (High0 > High1 && High1 > High2 && High2 > High3 &&
    Low0 > Low1 && Low1 > Low2 && Low2 > Low3) return(4);
if (High0 > High1 && High1 > High2 && Low0 > Low1 && Low1 > Low2) return(3);

return(0);
}  

int DetermineTrendShort()
{

if (Low0 < Low1 && Low1 < Low2 && Low2 < Low3 && Low3 < Low4 &&
    High0 < High1 && High1 < High2 && High2 < High3 && High3 < High4) return(5);
if (Low0 < Low1 && Low1 < Low2 && Low2 < Low3 && 
    High0 < High1 && High1 < High2 && High2 < High3) return(4);
if (Low0 < Low1 && Low1 < Low2 && High0 < High1 && High1 < High2) return(3);

//Print(AllPairs[i], " L0 = ", Low0, " L1 = ", Low1, " L2 = ", Low2, " L3 = ", Low3," L4 = ", Low4);

return(0);
}  

void WriteText(string Pair, int c)
{
  int xp = HorizPos;
  int yp = VertPos+c*VertSpacing;

  objname = StringConcatenate("WSGLINE", c);

  if(ObjectFind(objname) != 0)
  {
  ObjectCreate(objname,OBJ_LABEL,Window,0,0);
  ObjectSet(objname,OBJPROP_CORNER,Corner);
  ObjectSet(objname,OBJPROP_XDISTANCE,xp);
  ObjectSet(objname,OBJPROP_YDISTANCE,yp);
  if (LongBars != 0) colr = LongColor;
  if (ShortBars != 0) colr = ShortColor;  
  TextLine=StringConcatenate(Pair, TrendText, SpreadText);  
  ObjectSetText(objname,TextLine,FontSize,FontName,colr);
  }
}


void del_obj()
{
  int k=0;
  while (k<ObjectsTotal())   {
    string objname = ObjectName(k);
    string oname = StringSubstr(objname,0,7);
    if (oname == "WSGLINE")  
      ObjectDelete(objname);
    else
      k++;
  }    
  return(0);
}